﻿using System;
using System.Collections.Generic;
using System.Text.RegularExpressions;
using System.Windows.Input;
using System.Windows.Forms;
using System.Drawing;
using Microsoft.VisualStudio.TestTools.UITesting;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Microsoft.VisualStudio.TestTools.UITest.Extension;
using Keyboard = Microsoft.VisualStudio.TestTools.UITesting.Keyboard;


namespace Benday.Presidents.CodedUiTests
{
    /// <summary>
    /// Summary description for CodedUITest1
    /// </summary>
    [CodedUITest]
    public class PresidentEditorCodedUiFixture
    {
        /*
        [TestMethod]
        [Ignore]
        [TestCategory("CodedUi")]
        public void VerifyChesterArthurInChrome()
        {
            BrowserWindow.CurrentBrowser = "Chrome";
            BrowserWindow.Launch(new Uri("http://localhost:21310/"));
            // this.UIMap.OpenApp();
            this.UIMap.NavigateToChesterArthur();
            this.UIMap.AssertFirstName();
            this.UIMap.AssertLastName();
            // To generate code for this test, select "Generate Code for Coded UI Test" from the shortcut menu and select one of the menu items.
        }
        */

        [TestMethod]
        [TestCategory("CodedUi")]
        public void VerifyChesterArthurInIE()
        {
            RunApp();
            this.UIMap.NavigateToChesterArthur();
            this.UIMap.AssertFirstName();
            this.UIMap.AssertLastName();
        }

        private string GetConfigurationValue(string key, string defaultValue)
        {

            var environmentVariables = Environment.GetEnvironmentVariables();

            if (environmentVariables.Contains(key) == false)
            {
                TestContext.WriteLine(
                    "No environment variable named '{0}'.  Returning default value '{1}'.",
                    key, defaultValue);

                return defaultValue;
            }
            else
            {
                var temp = environmentVariables[key];

                if (temp == null)
                {
                    TestContext.WriteLine(
                        "Environment variable named '{0}' is null.  Returning default value '{1}'.",
                        key, defaultValue);

                    return defaultValue;
                }
                else
                {
                    TestContext.WriteLine(
                        "Environment variable '{0}' found with value '{1}'.",
                        key, temp);

                    return temp.ToString();
                }
            }
        }

        private void RunApp()
        {
            // PrintDebugInfo();

            string defaultUrl = "http://default-url/";
            string url = GetConfigurationValue("Presidents.CodedUI.WebAppUrl", defaultUrl);
            
            TestContext.WriteLine("Running app with url '{0}'.", url);

            Assert.AreNotEqual<string>(defaultUrl, url, "Should not be using default url.");
            BrowserWindow.Launch(new Uri(url));
        }

        private void PrintDebugInfo()
        {
            TestContext.WriteLine("*** TestContext.Properties -- START ***");

            foreach (var key in TestContext.Properties.Keys)
            {
                TestContext.WriteLine("TestContext.Property '{0}' - '{1}'", key, TestContext.Properties[key]);
            }

            TestContext.WriteLine("*** TestContext.Properties -- END ***");

            TestContext.WriteLine("*** Environment Variables -- START ***");

            var envVariables = Environment.GetEnvironmentVariables();

            foreach (var key in envVariables.Keys)
            {
                TestContext.WriteLine("Env Var '{0}' - '{1}'", key, envVariables[key]);
            }

            TestContext.WriteLine("*** Environment Variables -- END ***");
        }



        #region Additional test attributes

        // You can use the following additional attributes as you write your tests:

        ////Use TestInitialize to run code before running each test 
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{        
        //    // To generate code for this test, select "Generate Code for Coded UI Test" from the shortcut menu and select one of the menu items.
        //}

        ////Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{        
        //    // To generate code for this test, select "Generate Code for Coded UI Test" from the shortcut menu and select one of the menu items.
        //}

        #endregion

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }
        private TestContext testContextInstance;

        public UIMap UIMap
        {
            get
            {
                if ((this.map == null))
                {
                    this.map = new UIMap();
                }

                return this.map;
            }
        }

        private UIMap map;
    }
}
